import { AllHTMLAttributes } from 'react';
import { ChildNodesType, ComponentConfigsType, MirrorModalFieldType, PropsConfigSheetType, SelectedInfoBaseType, STATE_PROPS } from 'lingxi-editor-core';
/**
 * 处理样式
 * @param key
 * @param isHidden
 * @param isDragTarget
 * @param className
 * @param animateClass
 * @param isDropTarget
 */
export declare function handlePropsClassName(key: string, isHidden: boolean, isDragTarget: boolean, className: any, animateClass: string): string;
export declare type DragAddStatusType = {
    dragKey?: string;
    isDragAdd?: boolean;
    isDragAddChild?: boolean;
};
export declare function handleChildNodes(specialProps: SelectedInfoBaseType, componentConfigs: ComponentConfigsType, children?: ChildNodesType, dragKey?: string, isDragAdd?: boolean, isDragAddChild?: boolean): any;
/**
 * 处理弹窗类容器
 * @param mirrorModalField
 * @param iframeId
 */
export declare function handleModalTypeContainer(mirrorModalField: MirrorModalFieldType): {
    displayPropName: string;
    mountedProps: any;
};
/**
 * 处理容器组件属性
 * @returns {*|{onMouseOver: (function(*=): void), onClick: (function(*=): *), onDragStart: (function(*=): void), onDragEnter: (function(*=): *)}}
 */
export declare function handleEvents(specialProps: SelectedInfoBaseType, isSelected: boolean, componentName: string, childNodes?: ChildNodesType): {
    onClick: (e: Event) => void;
    onMouseOver: (e: Event) => void;
    onDragStart: (e: Event) => void;
    onDragEnd: () => import("lingxi-editor-core").BrickAction;
};
export declare type HookState = {
    componentConfigs: ComponentConfigsType;
    propsConfigSheet: PropsConfigSheetType;
};
export declare const stateSelector: STATE_PROPS[];
export declare function controlUpdate(prevState: HookState, nextState: HookState, key: string): boolean;
export interface CommonPropsType extends AllHTMLAttributes<any> {
    specialProps: SelectedInfoBaseType;
    isDragAddChild?: boolean;
    [propsName: string]: any;
}
export declare function propAreEqual(prevProps: CommonPropsType, nextProps: CommonPropsType): boolean;
