import React, { memo } from 'react';
import styles from './index.less';
import configs, { ACTIONS } from './configs';
function ActionSheet(props) {
    const { isOut, isRoot, hasChildNodes } = props;
    return (React.createElement("div", { className: styles['container'], style: { top: isOut ? 16 : 0 } }, configs.map((config) => {
        const { icon, action, type } = config;
        if (isRoot && type === ACTIONS.copy)
            return null;
        if (!hasChildNodes && type === ACTIONS.clear)
            return null;
        return (React.createElement("div", { className: styles['action-btn'], onClick: action, key: type },
            React.createElement("img", { src: icon, className: styles['action-icon'] })));
    })));
}
export default memo(ActionSheet);
