import { useSelector } from 'lingxi-editor-core';
import { useEffect } from 'react';
import { handleSelectedStatus } from '../common/events';
import { isEqualKey } from '../utils';
function controlUpdate(prevState, nextState, key, isModal) {
    const { selectedKey: prevSelectedKey, propName: prevPropName, domTreeKeys: prevDomTreeKeys } = prevState.selectedInfo || {};
    const { selectedKey, propName, domTreeKeys } = nextState.selectedInfo || {};
    if (!prevSelectedKey && selectedKey) {
        if (isModal) {
            if (domTreeKeys.includes(key)) {
                return true;
            }
        }
        return isEqualKey(key, selectedKey);
    }
    if (prevSelectedKey && !selectedKey) {
        if (isModal) {
            if (prevDomTreeKeys.includes(key)) {
                return true;
            }
        }
        return isEqualKey(key, prevSelectedKey);
    }
    if (prevSelectedKey && selectedKey) {
        if (isModal) {
            if (!prevDomTreeKeys.includes(key) && domTreeKeys.includes(key) || prevDomTreeKeys.includes(key) && !domTreeKeys.includes(key)) {
                return true;
            }
        }
        if (prevSelectedKey !== selectedKey) {
            return isEqualKey(key, prevSelectedKey) || !isEqualKey(key, prevSelectedKey) && isEqualKey(key, selectedKey);
        }
        else {
            return propName !== prevPropName;
        }
    }
    return false;
}
export function useSelect(specialProps, isModal) {
    const { key } = specialProps;
    const { selectedInfo } = useSelector(['selectedInfo'], (prevState, nextState) => controlUpdate(prevState, nextState, key, isModal));
    const { selectedKey, domTreeKeys: selectedDomKeys } = selectedInfo || {};
    const isSelected = isEqualKey(key, selectedKey);
    useEffect(() => {
        if (isSelected) {
            handleSelectedStatus(null, false, specialProps);
        }
    }, []);
    return { selectedDomKeys, isSelected };
}
